# Enable debug mode
%define debug 0

Name:		xsane
Version:	0.999
Release:	%mkrel 4
Summary:	Frontend for the SANE scanner interface
Group:		Graphics
URL:		http://www.xsane.org/
Source:		ftp://ftp.sane-project.org/pub/sane/xsane/%{name}-%version.tar.xz
Patch0:		xsane-0.995-xdg-open.patch
Patch1:		xsane-0.995-close-fds.patch
Patch2: 	xsane-0.996-no-eula.patch
Patch3:		xsane-0.997-off-root-build.patch
Patch4:		xsane-0.999-no-file-selected.patch
Patch5:		xsane-0.997-ipv6.patch
Patch6:		xsane-0.998-preview-selection.patch
###Patch7:		xsane-0.998-libpng.patch
Patch8:		xsane-0.998-wmclass.patch
Patch9: 	xsane-desktop.patch
Patch10:	xsane-0.999-man-page.patch
Patch11:	xsane-0.999-pdf-no-high-bpp.patch
Patch12:	xsane-0.999-lcms2.patch
Patch13:	xsane-0.999-coverity.patch
Patch14:	xsane-0.999-snprintf-update.patch
Patch15:	xsane-0.999-signal-handling.patch

License:	GPLv2+
Requires:	libsane >= 1.0.4
# Contains "www-browser" script
Requires:	desktop-common-data
# This is for the drakxtools so that they can install a GUI for scanning
# but decide depending on the system environment which GUI actually to
# install
Provides:       scanner-gui
#----------------------------------------------
BuildRequires:	pkgconfig(sane-backends)
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	gimp-devel >= 2.0
BuildRequires:	imagemagick
BuildRequires:  pkgconfig(lcms2)
BuildRequires:  pkgconfig(libtiff-4)
BuildRequires:  libgphoto-devel
BuildRequires:  libv4l-devel
#----------------------------------------------
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
Obsoletes:  	%name < %version
Suggests:	gocr

%description
XSane is an X based interface for the SANE (Scanner Access Now Easy)
library, which provides access to scanners, digital cameras, and other
capture devices.  XSane is written in GTK+ and provides control for
performing the scan and then manipulating the captured image.

You may install xsane-gimp if you want the GIMP plug-in.

%package gimp
Summary: 	GIMP plug-in which provides the SANE scanner interface
Group: 		Graphics
Requires: 	sane >= 1.0, %{name} >= %{version}

%description gimp
This package provides the regular XSane frontend for the SANE scanner
interface, but it works as a GIMP 2.0 plug-in.  You must have GIMP 2.0 (or
newer) installed to use this package.


%package doc
Summary: 	Documentation files for xsane
Group: 		Books/Computer books
Requires: 	sane >= 1.0, %{name} >= %{version}

%description doc
This package provides documentation fies for the XSane frontend.


%prep
%setup -q
%patch0 -p1 -b .xdg-open
#%patch1 -p1 -b .close-fds
#%patch2 -p1 -b .no-eula
%patch3 -p1 -b .off-root-build
#%patch4 -p1 -b .no-file-selected
#%patch5 -p1 -b .ipv6
#%patch6 -p1 -b .preview-selection.patch
#%patch7 -p1 -b .libpng
%patch8 -p1 -b .wmclass
%patch9 -p1 -b .desktop-file
%patch10 -p1 -b .man-page
%patch11 -p1 -b .pdf-no-high-bpp
# %patch12 -p1 -b .lcms2
#%patch13 -p1 -b .coverity
%patch14 -p1 -b .snprintf-update
%patch15 -p1 -b .signal-handling

%build
%configure2_5x
%make_build
mv src/xsane src/xsane-gimp

make clean
%configure2_5x  --disable-gimp
%make_build

%install
%make_install

install src/xsane-gimp %{buildroot}%{_bindir}

%find_lang %{name}

mkdir -p %{buildroot}%{_iconsdir}/hicolor/{48x48,32x32,16x16}/apps
mv src/xsane-48x48.png %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{name}.png
#convert -scale 32 %{buildroot}/usr/share/pixmaps/xsane.xpm %{buildroot}%{_iconsdir}/hicolor/32x32/apps/%{name}.png
#convert -scale 16 %{buildroot}/usr/share/pixmaps/xsane.xpm %{buildroot}%{_iconsdir}/hicolor/16x16/apps/%{name}.png

# dynamic desktop support
%define launchers /etc/dynamic/launchers/scanner
mkdir -p %{buildroot}%{launchers}
cat > %{buildroot}%{launchers}/%{name}.desktop << EOF
[Desktop Entry]
Name=XSane \$device
Comment=XSane
Exec=%_bindir/xsane
Terminal=false
Icon=%{name}
Type=Application
EOF

%clean
rm -fr %{buildroot}

%files
%defattr(-,root,root)
%config(noreplace) %{launchers}/%{name}.desktop
%{_bindir}/xsane
%{_datadir}/applications/%{name}.desktop
##%{_datadir}/pixmaps/%{name}.xpm
%{_iconsdir}/hicolor/*/apps/*
%{_datadir}/sane/xsane/xsane-eula.txt
%{_datadir}/sane/xsane/xsane-gpl.txt
%{_datadir}/locale

%files gimp
%defattr(-,root,root)
%{_bindir}/xsane-gimp

%files doc
%defattr(-,root,root)
%doc xsane*
%{_datadir}/sane/*
%{_mandir}/man1/*
%exclude %{_datadir}/sane/xsane/xsane-eula.txt
%exclude %{_datadir}/sane/xsane/xsane-gpl.txt


%post
%update_menus

update-alternatives --install %{launchers}/kde.desktop scanner.kde.dynamic %{launchers}/%{name}.desktop 30
update-alternatives --install %{launchers}/gnome.desktop scanner.gnome.dynamic %{launchers}/%{name}.desktop 30

%postun
%update_menus

if [ $1 = 0 ]; then
  update-alternatives --remove scanner.kde.dynamic %{launchers}/%{name}.desktop
  update-alternatives --remove scanner.gnome.dynamic %{launchers}/%{name}.desktop
fi


%post gimp
if [ -d %_libdir/gimp ]; then
  GIMPDIR=`ls -d %_libdir/gimp/[012]*`
  [ -z "$GIMPDIR" ] && exit 0
  for i in $GIMPDIR;do
  [ -d $i/plug-ins ] || mkdir -p $i/plug-ins
  %{__ln_s} -f %_bindir/xsane-gimp $i/plug-ins/xsane
  done
fi

%postun gimp
if [ $1 = 0 ]; then
  if [ -d %_libdir/gimp ]; then
    GIMPDIR=`ls -d %_libdir/gimp/[012]*`
        [ -z "$GIMPDIR" ] && exit 0
        for i in $GIMPDIR;do
    [ -d $i/plug-ins ] || mkdir -p $i/plug-ins
    %{__rm} -f $i/plug-ins/xsane
        done
  fi
fi

%changelog
* Thu Aug 10 2023 onkelho <oh.quait at gmail.com> 0.999-4pclos2023
- rebuild against new version sane-1.2.1
- May 29, 2022
-  Merge branch '51-fix-warnings-from-cppcheck' into 'master' 
-  xsane-scan, xsane: final cppcheck updates.
-  alloca: purged remaining alloca from code base.
-  various: a number of fixes for issues as reported by cppcheck
- May 28, 2022
-  Merge branch 'gtk3-gamma-viewer' into 'master' 
- May 26, 2022
-  make small preview selection more visible
- May 25, 2022
-  fix preset area selection after action
-  preset area option_menu becomes combobox
-  medium option_menu becomes combobox
- May 23, 2022
-  fix C compiler string truncation warnings
-  no more own colormap setting
-  preview becomes drawing_area
- May 22, 2022
-  zoom becomes image
-  remove gtk1 related code
-  viewer becomes image
-  slider becomes image
-  draw histogram with cairo
-  fix valgrind invalid access error
-  xsane-gtk-back: fix for unused variable.
-  Merge branch 'gtk3-pixmap-list' into 'master'
-  fix xsane_save_ps function definition
-  fix missing typedef if compiled without LIBLCMS
- May 20, 2022
-  move actions that can destroy widgets into idle funcs
-  discussed amendments
-  fix sending emails
-  fix combobox getting destroyed unexpectedly
-  simplify treeview model
-  fix combobox getting destroyed unexpectedly
-  remove obsolete functions
-  list in email becomes treeview
-  list in multipage becomes treeview
-  list in batch scan becomes treeview
-  list in fax becomes treeview
-  use pixbuf in preview custom cursors
-  Remove unused variables (gimp)
-  Update german translation file
-  use pixbuf in choose device dialog
-  use pixbuf in translation dialog
-  use pixbuf in about dialog
-  use pixbuf in vendor
-  use pixbuf in xsane_set_window_icon
-  use pixbuf in viewer
-  use pixbuf in preview
-  use pixbuf in fax
-  use pixbuf in xsane-front-gtk
-  use pixbuf in xsane
-  use pixbuf in xsane-back-gtk
-  use pixbuf in email
-  Merge branch 'gtk3-less-option-menus' into 'master'
-  Merge branch 'gtk3-less-option-menus' into 'master'
-  amended keypress event handling
-  amended keypress event handling
- May 18, 2022
-  Debug keypress event
- May 16, 2022
-  Show accelerator for printer combobox
- May 14, 2022
-  xsane_back_gtk option_menu becomes combobox
-  filename_counter_step option_menu becomes combobox
-  xsane_option_menu becomes xsane_combobox
-  cms function option_menu becomes combobox
-  paper orientation option_menu becomes combobox
-  printer option_menu becomes combobox
-  filetype option_menu becomes combobox
-  zoom option_menu in viewer becomes combobox
-  preview_pipette_range option_menu becomes combobox
-  gray option_menu in setup becomes combobox
-  lineart mode option_menu becomes combobox
-  range mode option_menu becomes combobox
-  email authentication option_menu becomes combobox
-  tiff compression option_menu becomes combobox
-  filename_counter_len option_menu in setup becomes combobox
-  printer option_menu in setup becomes combobox
-  filetype option_menu in multipage becomes combobox
-  rotation option_menu in preview becomes combobox
-  ratio option_menu in preview becomes combobox
-  filetype option_menu in email becomes combobox
-  modus option_menu becomes combobox
-  Merge branch 'gtk3-removed-functions-type-conversions' into 'master'
-  Amended typecasts
- May 13, 2022
-  Merge branch 'improve-icon-installation' into 'master' 
-  Merge branch '50-fix-up-build-system-for-new-gimp-support' into 'master'
-  xsane-save: doesn't look like we need to strip '/' chars from device menu items
-  gimp: updated menu parameters for modern GIMP menus hierarchy. 
-  configure.in: updated GIMP checks for 2.10.0 minimal and only supported version
- May 11, 2022
-  Drop unused Windows icons 
-  Include all PNGs in xsane.ico
-  Drop unused XPM icons
-  Stop installing application XPM icon
-  Install the application PNG icons
-  Merge branch 'desktop-old-category' into 'master'
-  Fix valgrind use after free issue
-  Enable the code to compile with no additional warnings when using -Wconversion and -Wtype-limits
-  replace gtk_timeout with g_timeout
-  make input_tag a boolean input_active variable
-  replace gdk_input functions with glib functions
-  desktop: drop deprecated 'Application' category
-  Merge branch 'compiler-warnings' into 'master'
- May 07, 2022
-  Remove support for older gimp versions
- May 06, 2022
-  Simplify gimp #if defines
-  Update remaining language files
-  Update translation files (german)
-  Fix mismatch between function declaration and definition
-  gimp_image_parasite_attach becomes gimp_image_attach_parasite
-  Use gegl buffer for gimp
-  Follow new convention for registering gimp plugin
-  Merge branch 'gtk-migration-depreciated-functions' into 'master'
-  Correct wrong typecast
- May 05, 2022
-  gtk_entry_new_with_max_length seems to be gone in gtk3
-  gtk_container_children becomes gtk_container_get_children
-  gtk_label_set becomes gtk_label_set_text
-  gtk_entry_set_position becomes gtk_editable_set_position
-  Documentation says there is no point to call gtk_set_locale
-  gtk_menu_append becomes gtk_menu_shell_append
-  gtk_radio_button_group becomes gtk_radio_button_get_group
-  Merge branch 'gtk3-migration-type-cleanup' into 'master'
-  Replace (GObject *) type cast with G_OBJECT(...)
-  Fix type conversions
-  remove remaining occurances of GtkSignalFunc
-  fix types for xsane_progress_new
-  correct type for xsane_back_gtk_filetype_menu_new
-  Fix parameters for xsane_button_new_with_pixmap
-  Replace remaining instances of GtkObject with GObject
-  change list_item type to GObject
-  Fix data argument of g_signal_connect_swapped
-  use correct type for g_signal_emit_by_name
-  use correct types for g_signal_handlers_disconnect_by_func
-  use correct types for g_signal_handlers_unblock_by_func
-  use correct types for g_signal_handlers_block_by_func
-  use correct types for g_signal_connect_swapped
-  use correct types for g_signal_connect_after
-  use correct types for g_signal_connect
-  change gtk_obj_unref tk g_obj_unref
-  replace gtk_object_set_data with g_object_set_data
-  change gtk_object_get_data to g_object_get_data
-  Changed _KEY_ defines for gtk_widget_add_accelerator
-  Merge branch 'gtk3-migration-branch' into 'master'
-  Cleanup handling of return value of gtk_toggle_button_get_active
- May 04, 2022
-  Apply 1 suggestion(s) to 1 file(s)
-  use gtk_widget_get_allocation
-  use gtk_widget_get_realized
-  use gtk_widget_get_style
-  use gtk_widget_is_drawable
-  use gtk_widget_get_parent
-  use gtk_check_menu_item_get_active
-  use further gtk_adjustment_get_ functions
-  use gtk_adjustment_get_value/gtk_adjustment_set_value
-  use gtk_toggle_button_get_active
-  use gtk_widget_set_can_default
-  use gtk_widget_get_toplevel
-  use gtk_widget_get_window instead of ->window
- May 12, 2020
-  Merge branch 'master' into 'master' 
- May 01, 2020
-  make preview_calculate_full_scanner_surface to always correct scanner surface... 
- Apr 28, 2020
-  fix new bug with wrong processing of mouse buttons
- Apr 24, 2020
-  fix wrong bounding of selection
-  fix bug : 'blocked cursor' was not blocked and those not shown
- Apr 23, 2020
-  fix disappearing selection after changes of gamma correction
-  (1) split xsane_get_bounds to xsane_get_bounds_word and...
- Apr 19, 2020
-  remove mistakenly committed temporary code
-  redo of the previous commit
-  fix typo in preview_restore_image_from_file
-  New xsane_list_all_scanner_parameters for debugging
- Apr 17, 2020
-  add 'selection for half-frame of 135 format film'
- Apr 16, 2020
-  more fixes : selection, cursor
-  some fixes for selection
- Apr 15, 2020
-  more fixes, now for preview_update_surface
- Apr 13, 2020
-  more fixes
- Apr 12, 2020
-  draft version, now it can compile and run
- Apr 11, 2020
-  Intermediate upload of big changes, still in progress
- Apr 08, 2020
-  minor changes descriptions
- Apr 03, 2020
-  remove old blocked code
-  (1) rewrite preview_transform_coordinate_window_to_image() for the new...
- Apr 01, 2020
-  Fix for preview_transform_coordinate_device_to_window, the previous version was wrong
- Mar 31, 2020
-  Better calculations in preview_update_zoom_buttons
-  New preview_update_zoom_buttons() function for managing Zoom buttons, the code is simplified
- Mar 29, 2020
-  fix preview_restore_image_from_file(), preview images could not show up... 
-  fix preview_restore_image_from_file(), preview images could not show up...
- Mar 22, 2020
-  fix transformations of coordinates, fix display display of selections, fix code style.
- Mar 18, 2020
-  final changes for the new zoom maths

* Tue Mar 01 2022 tex - 0.999-3pclos2022
- rebuild against updates

* Sun Apr 07 2019 onkelho <oh.quait at gmail.com> 0.999-2pclos2019
- rebuild against new sane

* Wed Mar 06 2019 onkelho <oh.quait at gmail.com> 0.999-1pclos2019
- new ver-rel

* Sun Jun 15 2014 bb <bb> 0.998-3pclos2014
- rebuild against updated gphoto libs

* Mon Sep 05 2011 Texstar <texstar at gmail.com> 0.998-2pclos2011
- split doc files to make livecd smaller

* Tue Feb 01 2010 Ertain <sirius-c at iname.com> 0.998-1pclos2010
- 0.998

* Wed Oct 28 2009 Texstar <texstar at gmail.com> 0.996-1pclos2010
- gcc update

